<template>
  <div class="search-container">
    <button @click="toggleSearch" class="search-button">
      <svg
        v-if="!isSearchActive"
        xmlns="http://www.w3.org/2000/svg"
        fill="none"
        viewBox="0 0 24 24"
        stroke-width="1.5"
        stroke="currentColor"
        width="24"
        height="24"
      >
        <path
          stroke-linecap="round"
          stroke-linejoin="round"
          d="m21 21-5.197-5.197m0 0A7.5 7.5 0 1 0 5.196 5.196a7.5 7.5 0 0 0 10.607 10.607Z"
        />
      </svg>
    </button>
    <input
      v-show="isSearchActive"
      type="text"
      v-model="query"
      placeholder="Поиск"
      class="search-input"
      ref="searchInput"
      @blur="toggleSearch"
      list="search-for-products"
    />
    <datalist id="search-for-products">
      <option value="Римская туника"></option>
      <option value="Фланель"></option>
      <option value="Шорты"></option>
      <option value="Солнечные очки"></option>
      <option value="Хлопок"></option>
    </datalist>
  </div>
</template>

<script>
export default {
  data() {
    return {
      isSearchActive: false,
      query: "",
    };
  },
  methods: {
    toggleSearch() {
      this.isSearchActive = !this.isSearchActive;
      if (this.isSearchActive) {
        this.$nextTick(() => {
          this.$refs.searchInput.focus();
        });
      } else {
        this.query = "";
      }
    },
  },
};
</script>

<style scoped>
.search-container {
  position: relative;
  display: flex;
  align-items: center;
}
.search-button {
  border: none;
  background: none;
  cursor: pointer;
  padding: 8px;
  display: flex;
  align-items: center;
}

.search-input {
  width: 0;
  opacity: 0;
  border: none;
  border-bottom: 1px solid #ccc;
  outline: none;
  padding: 5px;
  transition: width 0.5s, opacity 0.5s;
}
.search-input:focus {
  width: 200px;
  opacity: 1;
  border-bottom: 1px solid blue;
}
</style>
